import junit.framework.TestCase;
import java.util.*;
/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestBasicQuicksort extends TestCase {
  
  QuickSort basingSort = new QuicksortBasic();
  
  public void testEmpty() {
    ArrayList<Integer> sortedArrayList = basingSort.sort(new ArrayList<Integer>());
    assert(sortedArrayList.size()==0); 
  }
  
  public void testSingleElement(){
    ArrayList<Integer> initialArrayList = new ArrayList<Integer>();
    initialArrayList.add(2);
    ArrayList<Integer> sortedArrayList = basingSort.sort(initialArrayList);
    assert( sortedArrayList.size() == initialArrayList.size() ); 
    
    ArrayList<Integer> officialResult = new ArrayList<Integer>(initialArrayList);
    Collections.sort(officialResult); // use java library for sorting the official result
    for(int i=0; i<officialResult.size(); i++){
      assert(officialResult.get(i)==sortedArrayList.get(i));
    }
  }
    
  public void testMultipleElements(){
    ArrayList<Integer> initialArrayList = new ArrayList<Integer>();
    initialArrayList.add(9);
    initialArrayList.add(2);
    initialArrayList.add(7);
    initialArrayList.add(5);
    ArrayList<Integer> sortedArrayList = basingSort.sort(initialArrayList);
    assert( sortedArrayList.size() == initialArrayList.size() ); 
    
    ArrayList<Integer> officialResult = new ArrayList<Integer>(initialArrayList);
    Collections.sort(officialResult); // use java library for sorting the official result
    for(int i=0; i<officialResult.size(); i++){
      assert(officialResult.get(i)==sortedArrayList.get(i));
    }
  }
  
  public void testWithNegativeNumbers(){
    ArrayList<Integer> initialArrayList = new ArrayList<Integer>();
    initialArrayList.add(9);
    initialArrayList.add(-2);
    initialArrayList.add(7);
    initialArrayList.add(5);
    ArrayList<Integer> sortedArrayList = basingSort.sort(initialArrayList);
    assert( sortedArrayList.size() == initialArrayList.size() ); 
    
    ArrayList<Integer> officialResult = new ArrayList<Integer>(initialArrayList);
    Collections.sort(officialResult); // use java library for sorting the official result
    for(int i=0; i<officialResult.size(); i++){
      assert(officialResult.get(i)==sortedArrayList.get(i));
    }
  }
  
  public void testWithDuplicateNumbers(){
    ArrayList<Integer> initialArrayList = new ArrayList<Integer>();
    initialArrayList.add(9);
    initialArrayList.add(-2);
    initialArrayList.add(7);
    initialArrayList.add(-2);
    ArrayList<Integer> sortedArrayList = basingSort.sort(initialArrayList);
    assert( sortedArrayList.size() == initialArrayList.size() ); 
    
    ArrayList<Integer> officialResult = new ArrayList<Integer>(initialArrayList);
    Collections.sort(officialResult); // use java library for sorting the official result
    for(int i=0; i<officialResult.size(); i++){
      assert(officialResult.get(i)==sortedArrayList.get(i));
    }
  }
  
}
